﻿-- Author      : Nogarder
-- Create Date : 2012/12/29 13:01:07
local NPA_GetTime=NPA.GetTime
local NPA_NamePlateDataParser_AddElements=NPA.NamePlateDataParser.AddElements
local NPA_TextureManager_ManageTexture2=NPA.TextureManager.ManageTexture2

local NPA_NamePlateModuleManager_ZipModule=NPA.NamePlateModuleManager.ZipModule
local NPA_NamePlateModuleManager_UnzipModule=NPA.NamePlateModuleManager.UnzipModule

local NPA_BarManager_SetBarGroupColor=NPA.BarManager.SetBarGroupColor
local NPA_BarManager_SetBarGroup=NPA.BarManager.SetBarGroup

local NPA_Color_GetColorBySpellSchool=NPA.Color.GetColorBySpellSchool

local NPA_NumberManager_SetNumber=NPA.NumberManager.SetNumber
local NPA_NumberManager_SetNumberColor=NPA.NumberManager.SetNumberColor

local NPA_FrameMacro_SetFrameTimer=NPA.FrameMacro.SetFrameTimer

local NPA_NumberManager_SetTimerNumber=NPA.NumberManager.SetTimerNumber

--the icon
NPA.NamePlateModuleManager.RegisterDataModule("Icon","Casting",function(framedata,textureframe,setting)
	--add event elements
 	--name update
	NPA_NamePlateDataParser_AddElements(framedata,textureframe,"Casting_Updated",function(framedata)
		local castinfo=framedata.UnitData.CastInfo
		local nTime=NPA_GetTime()
		--endtime==nil means casting is ended
		if(castinfo and castinfo.EndTime and castinfo.EndTime>nTime)then
			--set frame timer,  function(frame,starttime,endtime,revers,onupdatefunc,timerendfunc)
			NPA_FrameMacro_SetFrameTimer(textureframe,castinfo.StartTime,castinfo.EndTime,
				--onupdate func
				nil, --do nothing
				--on timer end func, hide it
				function(data)
					NPA_NamePlateModuleManager_ZipModule(textureframe)
				end)
			--reset texcoord
			textureframe.Icon:SetTexCoord(0,1,0,1)
			textureframe.Icon:SetTexture(castinfo.Icon)
			NPA_NamePlateModuleManager_UnzipModule(textureframe)
		else
			NPA_NamePlateModuleManager_ZipModule(textureframe)
		end
	end)
end)
--the bar
NPA.NamePlateModuleManager.RegisterDataModule("BarGroup","Casting",function(framedata,bargroupframe,setting)
	--add event elements
 	--name update
	local colormode=setting.ColorMode
	NPA_NamePlateDataParser_AddElements(framedata,bargroupframe,"Casting_Updated",function(framedata)
		local castinfo=framedata.UnitData.CastInfo
		local nTime=NPA_GetTime()
		--check endtime>ntime to prevent combatlog miss
		if(castinfo and castinfo.EndTime and castinfo.EndTime>nTime)then
			--set frame timer,  function(frame,starttime,endtime,revers,onupdatefunc,timerendfunc)
			NPA_FrameMacro_SetFrameTimer(bargroupframe,castinfo.StartTime,castinfo.EndTime,
				--onupdate func
				function(nTime,data)
					local current=data.EndTime-nTime
					--don't have to check it , it's done in timer
					if(castinfo.Channeling)then --revers channeling
						NPA_BarManager_SetBarGroup(bargroupframe,current/data.Length)
					else
						NPA_BarManager_SetBarGroup(bargroupframe,1-(current/data.Length))
					end
				end,
				--on timer end func, hide it
				function(data)
					NPA_NamePlateModuleManager_ZipModule(bargroupframe)
				end)
			-- color mode
			--color by school
			if(colormode==5)then 
				local color=NPA_Color_GetColorBySpellSchool(castinfo.School)
				NPA_BarManager_SetBarGroupColor(bargroupframe,color)
			end
			--show it
			NPA_NamePlateModuleManager_UnzipModule(bargroupframe)
		else
			NPA_NamePlateModuleManager_ZipModule(bargroupframe)
		end
	end)
end)
--the timer number
NPA.NamePlateModuleManager.RegisterDataModule("Number","Casting",function(framedata,numberframe,setting)
	--add event elements
 	--name update
	local colormode=setting.ColorMode
	NPA_NamePlateDataParser_AddElements(framedata,numberframe,"Casting_Updated",function(framedata)
		local castinfo=framedata.UnitData.CastInfo
		local nTime=NPA_GetTime()
		--check endtime>ntime to prevent combatlog miss
		if(castinfo and castinfo.EndTime and castinfo.EndTime>nTime)then
			--set frame timer,  function(frame,starttime,endtime,revers,onupdatefunc,timerendfunc)
			NPA_FrameMacro_SetFrameTimer(numberframe,castinfo.StartTime,castinfo.EndTime,
				--onupdate func
				function(nTime,data)
					local current=data.EndTime-nTime
					NPA_NumberManager_SetNumber(numberframe,current,data.Length,true)
				end,
				--on timer end func, hide it
				function(data)
					NPA_NamePlateModuleManager_ZipModule(numberframe)
				end)
			-- color mode
			--color by school
			if(colormode==5)then 
				local color=NPA_Color_GetColorBySpellSchool(castinfo.School)
				NPA_NumberManager_SetNumberColor(numberframe,color)
			end
			--show it
			NPA_NamePlateModuleManager_UnzipModule(numberframe)
		else
			NPA_NamePlateModuleManager_ZipModule(numberframe)
		end
	end)
end)

--the name
NPA.NamePlateModuleManager.RegisterDataModule("Text","Casting",function(framedata,textframe,setting)
	--add event elements
	local colormode=setting.ColorMode
 	--hook name update
	NPA_NamePlateDataParser_AddElements(framedata,textframe,"Casting_Updated",function(framedata)
		local castinfo=framedata.UnitData.CastInfo
		local nTime=NPA_GetTime()
		--endtime==nil means casting is ended
		if(castinfo and castinfo.EndTime and castinfo.EndTime>nTime)then
			--set frame timer,  function(frame,starttime,endtime,revers,onupdatefunc,timerendfunc)
			NPA_FrameMacro_SetFrameTimer(textframe,castinfo.StartTime,castinfo.EndTime,
				--onupdate func
				nil, -- does nothing when updating
				--on timer end func, hide it
				function(data)
					NPA_NamePlateModuleManager_ZipModule(textframe)
				end)
			--set text
			textframe.Text:SetText(castinfo.Name)
			--color mode
			if(colormode==5)then --color by school
				local color=NPA_Color_GetColorBySpellSchool(castinfo.School)
				textframe.Text:SetTextColor(color.R,color.G,color.B,color.A)
			end
			--
			NPA_NamePlateModuleManager_UnzipModule(textframe)
		else
			NPA_NamePlateModuleManager_ZipModule(textframe)
		end
	end)
end)
--casting texture
NPA.NamePlateModuleManager.RegisterDataModule("TextureGroup","Casting",function(framedata,textureframe,setting)
	--add event elements
	NPA_NamePlateDataParser_AddElements(framedata,textureframe,"Casting_Updated",function(framedata)
		local castinfo=framedata.UnitData.CastInfo
		local nTime=NPA_GetTime()
		--endtime==nil means casting is ended
		if(castinfo and castinfo.EndTime and castinfo.EndTime>nTime)then
			--set frame timer,  function(frame,starttime,endtime,revers,onupdatefunc,timerendfunc)
			NPA_FrameMacro_SetFrameTimer(textureframe,castinfo.StartTime,castinfo.EndTime,
				--onupdate func
				nil, -- does nothing when updating
				--on timer end func, hide it
				function(data)
					NPA_NamePlateModuleManager_ZipModule(textureframe)
				end)
			--show it
			NPA_NamePlateModuleManager_UnzipModule(textureframe)
		else
			NPA_NamePlateModuleManager_ZipModule(textureframe)
		end
	end)
end)
--inturrept shield
NPA.NamePlateModuleManager.RegisterDataModule("TextureGroup","CastingShield",function(framedata,textureframe,setting)
	--add event elements
	NPA_NamePlateDataParser_AddElements(framedata,textureframe,"Casting_Updated",function(framedata)
		local castinfo=framedata.UnitData.CastInfo
		local nTime=NPA_GetTime()
		--endtime==nil means casting is ended
		if(castinfo and castinfo.EndTime and castinfo.EndTime>nTime and castinfo.NoInterrupt)then
			--set frame timer,  function(frame,starttime,endtime,revers,onupdatefunc,timerendfunc)
			NPA_FrameMacro_SetFrameTimer(textureframe,castinfo.StartTime,castinfo.EndTime,
				--onupdate func
				nil, -- does nothing when updating
				--on timer end func, hide it
				function(data)
					NPA_NamePlateModuleManager_ZipModule(textureframe)
				end)
			--show it
			NPA_NamePlateModuleManager_UnzipModule(textureframe)
		else
			NPA_NamePlateModuleManager_ZipModule(textureframe)
		end
	end)
end)